#pragma once

#include <concepts>

#include <vulkan/vulkan.hpp>

#include "Swapchain.hpp"
#include "Window.hpp"

class Renderer {
public:
    explicit Renderer(const Window& window);

private:
    vk::UniqueInstance   m_instance;
    vk::UniqueSurfaceKHR m_surface;

    vk::PhysicalDevice m_physical_device;
    uint32_t           m_queue_family_index;
    vk::UniqueDevice   m_device;
    vk::Queue          m_queue;

    std::optional<Swapchain> m_swapchain;

    vk::UniqueRenderPass m_render_pass;
};
